/*
  Copyright Red Hat, Inc. 2006

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
  Free Software Foundation; either version 2, or (at your option) any
  later version.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; see the file COPYING.  If not, write to the
  Free Software Foundation, Inc.,  675 Mass Ave, Cambridge, 
  MA 02139, USA.
*/

#include "Virt.h"
#include "utils.h"

using namespace std;

bool Virt::virt_guest(void) {
    try {
        String out, err;
        int status;
        vector<String> args;
        if (utils::execute(DMIDECODE_PATH, args, out, err, status, false))
            throw command_not_found_error_msg(DMIDECODE_PATH);
        if (status != 0)
			throw String("dmidecode failed");
        if (out.find("Vendor: Xen") != out.npos)
            return true;
        if (out.find("Manufacturer: Xen") != out.npos)
            return true;
    } catch ( ... ) {}
    return false;
}
